open Types
open Coercions
open Terms

(* [coercion polarity p loc co ty] takes a polarity [polarity]
   a printing environment [p] a location [loc], a coercion [co]
   of domain [ty], and returns a pair [(ty', ct)] of a function [ct]. 
   that given a (located) term of type [ty] returns an eta-equivalent (1)
   (located) term of type [ty'] when the polarity is true (the roles of
   [ty] and [ty'] are exchanged when polarity is false).
   Moreover [ct] uses its argument linearly. 

   (1) Due to the absence of a pattern-matching form for records, 
   we allow the use of a record let-binding in [ct].
*)

val coercion :
    Export.env -> Error.location -> loc_coercion -> ftype  ->
      ftype * (loc_fterm -> loc_fterm)

